#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 1A.e - Correction de l'interrogation écrite du 26 septembre 2015
# 
# tests, boucles, fonctions

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Enoncé 1

# #### Q1
# 
# Le programme suivant provoque une erreur pourquoi ?

# In[2]:


tab = [1, 3]
for i in range(0, len(tab)):
    print(tab[i] + tab[i+1])


# On découvre le problème en ajoutant des affichages intermédiaires :

# In[3]:


tab = [1, 3]
for i in range(0, len(tab)):
    print(i, i+1, len(tab))
    print(tab[i] + tab[i+1])


# A la dernière itération, $i+1$ dévient égal à la longueur de la liste ``tab`` or le dernier indice d'un tableau est ``len(tab)-1``.

# #### Q2
# 
# Où est l'erreur de syntaxe ?

# In[4]:


n = 1
if n = 1:
    y = 0
else:
    y = 1


# Le test d'égalité s'écrit ``==``.

# #### Q3
# 
# On associe la valeur 1 à la lettre *a*, 2 à *b* et ainsi de suite. Ecrire une fonction qui fait la somme de ces valeurs pour une chaîne de caractères.
# 
# Exemple :  elu  $\rightarrow$ 5 + 12 + 21 = 38

# In[5]:


def somme_caracteres(mot):
    s = 0
    for c in mot :
        s += ord(c) - ord("a") + 1
    return s

somme_caracteres("elu")


# On peut l'écrire de façon plus courte :

# In[6]:


def somme_caracteres(mot):
    return sum(ord(c) - ord("a") + 1 for c in mot)

somme_caracteres("elu")


# ### Enoncé 2

# #### Q1
# 
# Barrez les lignes qui produiraient une erreur à l'exécution et dire pourquoi ?

# In[7]:


y = "a" * 3 + 1
z = 3 * "a" + 1
print(y,z)


# Les deux premières lignes sont incorrects car on essaye d'ajouter une chaîne de caractères à un nombre. La première opération est correcte ``"a" * 3``. Dans un sens comme dans l'autre, elle donne ``"aaa"``. Mais on ne peut ajouter 1 à ``"aaa"``.

# #### Q2
# 
# Que vaut ``l`` à la fin du programme ?

# In[8]:


l = []
for i in range(0, 10):
    l.append([i])
print(l)


# Il ne faut pas confondre la méthode [append](https://docs.python.org/3.4/tutorial/datastructures.html#more-on-lists) et [extend](https://docs.python.org/3.4/tutorial/datastructures.html#more-on-lists).

# In[9]:


l = []
for i in range(0, 10):
    l.extend([i])
print(l)


# #### Q3
# 
# Ecrire une fonction qui prend une chaîne de caractères et qui lui enlève une lettre sur 2.

# In[10]:


def un_sur_deux(mot):
    s = ""
    for i,c in enumerate(mot):
        if i % 2 == 0:
            s += c
    return s

un_sur_deux("python")


# Ou plus court encore :

# In[11]:


def un_sur_deux(mot):
    return "".join( c for i,c in enumerate(mot) if i % 2 == 0 )

un_sur_deux("python")


# In[12]: